#include <Adafruit_NeoPixel.h>
#include <Servo.h>

#define PIN 7
#define SERVO_LEFT 5
#define SERVO_RIGHT 3
#define SERVO_HEAD 9
#define SERVO_TAIL 6

Servo myservo_left;
Servo myservo_right;
Servo myservo_head;
Servo myservo_tail;
Adafruit_NeoPixel strip = Adafruit_NeoPixel(2, 7, NEO_GRB + NEO_KHZ800);

uint8_t brightness = 255;

void setup() {
  
  // put your setup code here, to run once:
  strip.begin();
  
  myservo_left.attach(SERVO_LEFT);
  myservo_right.attach(SERVO_RIGHT);
  myservo_head.attach(SERVO_HEAD);
  myservo_tail.attach(SERVO_TAIL);

  strip.setPixelColor(0, strip.Color(brightness, brightness, brightness));
  strip.setPixelColor(1, strip.Color(brightness, brightness, brightness));
  strip.show(); // Initialize all pixels to 'off'
  delay(500);
  myservo_left.write(90);
  delay(500);
  myservo_right.write(90);
  delay(500);
  myservo_head.write(90);
  delay(500);
  myservo_tail.write(90);
  delay(500);
}

void loop() {

  walk();
  walk();
  walk();
  walk();
  walk();
  sweep_head_and_tail();
  sweep_head_and_tail();
  flash();
}

void flash()
{
  uint8_t twelve = 83;

  for (uint8_t i = 0; i<24; i++)
  {
    strip.setPixelColor(0, strip.Color(brightness, 0, 0));
    strip.setPixelColor(1, strip.Color(0, 0, brightness));
    strip.show(); // Initialize all pixels to 'off'
    delay(twelve);
    strip.setPixelColor(0, strip.Color(0, 0, brightness));
    strip.setPixelColor(1, strip.Color(brightness, 0, 0));
    strip.show(); // Initialize all pixels to 'off'
    delay(twelve);
  }
  strip.setPixelColor(0, strip.Color(brightness, brightness, brightness));
  strip.setPixelColor(1, strip.Color(brightness, brightness, brightness));
  strip.show(); // Initialize all pixels to 'off'
}

void sweep_head_and_tail()
{
  for (uint8_t pos = 90; pos <= 120; pos += 1) 
  {
    myservo_head.write(pos);
    myservo_tail.write(pos);
    delay(10);
  }
  for (uint8_t pos = 120; pos >= 60; pos -= 1) 
  {
    myservo_head.write(pos);
    myservo_tail.write(pos);
    delay(10);
  }
  for (uint8_t pos = 60; pos <= 90; pos += 1) 
  {
    myservo_head.write(pos);
    myservo_tail.write(pos);
    delay(10);
  }
}

void walk()
{
  for (uint8_t pos = 90; pos <= 120; pos += 1) 
  {
    myservo_right.write(pos);
    myservo_left.write(pos);
    delay(10);
  }
  
  for (uint8_t pos = 120; pos >= 60; pos -= 1) 
  {
    myservo_right.write(pos);
    myservo_left.write(pos);
    delay(10);
  }

  for (uint8_t pos = 60; pos <= 90; pos += 1) 
  {
    myservo_right.write(pos);
    myservo_left.write(pos);
    delay(10);
  }
}
